
### ParInt installation variable file:

### This file defines variables used by the top-level Makefile
### It should be edited upon installation to reflect the installed
### environment.  See the Readme.txt file for details.

### This is the ParInt variable holding the location of the include
### directory of the version of MPI used:
PI_MPI_IHOME	= /home/other/distsys/mpich/include

### This is the cc command to use.  It will reflect the MPI version
### used: 
CC		= /home/other/distsys/mpich/bin/mpicc

### This is the f77 command to use.
F77		= f77

### (To switch between different compatible versions of MPI, you should
### only have to change PI_MPI_IHOME and CC, make clean, and re-make ParInt)

### This is the top-level directory of ParInt.  Note that it is
### distinguished from the PI_HOME environment variable that is
### normally defined in the user's .cshrc file:
_PI_HOME	= /home/other/parint/parint1.1

### For release 1.1, this should be set to the MPI directory
PI_VRSN_HOME	= $(_PI_HOME)/src/mpi

### This is the directory where the integrand function source lies,
### along with the Makefile that makes the ifcn library.  After
### installation, change this (if you create your own library) to
### point to your ifcn directory outside of the parint1.1 directory:
PI_IFCN_HOME    = $(_PI_HOME)/samp-fcns

### This is the .a file that contains the integrand function library.
PI_IFCN_LIB     = $(_PI_HOME)/samp-fcns/pi-ifcns.a

### These point to the directory containing "sunmath.h", and specify
### the cc option for including the Sun math libs.  On Sun/Solaris
### systems, these must be specially set to use the long double math
### functions.  On other systems -- ???.  Undefine these (comment them
### out) if *not* using long doubles, but leaving them in is not a
### problem:
#PI_SUNM_INC     = -I/opt/SUNWspro/SC4.2/include/cc
#PI_SUNM_LIB     = -lsunmath

