/*        File: math-adapt.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: All versions
   Description: Header file for misc function needed by adaptive partitioning algorithm
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/include/math-adapt.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:31 $

                $Log: math-adapt.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:31  parint
                Initial checkin


       Version: 01/13/98  rrz  Original (from scavenged code)
		05/12/98  rrz  Code freeze for ParInt1.0
		05/27/99  rrz  Add eps_ratio() macro
		05/27/99  rrz  Add err_ratio() macro
		07/13/99  rrz  Add err_ratio_2() macro for logging
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/

#ifndef MATH_ADAPT_H
#define MATH_ADAPT_H

#include <pi-defs.h>
#include <parint.h>
#include <math-misc.h>

#define err_ratio(norm_estabs, eps)              ((norm_estabs) / (eps))
#define err_ratio_2(estabs, nfcns, eps)          (infNorm((estabs), (nfcns)) / (eps))
#define eps_ratio(eps, last_sent_eps)    ((last_sent_eps) == 0.0                               \
					  ? 0.0                                                \
					  : absol((eps) - (last_sent_eps)) / (last_sent_eps))

#define calc_new_eps(eps_a, eps_r, result, nfcns)  max((eps_a), (eps_r) * infNorm(result, nfcns))
#define result_close_enough(estabs, eps, nfcns)    (infNorm(estabs, nfcns) <= eps)

extern void clear_estabs(pi_base_t estabs[], int nfcns);
extern void clear_results(pi_base_t results[], pi_base_t estabs[], int nfcns);
extern void update_results(const update_t *update_p, int nfcns, pi_base_t result[], 
			   pi_base_t estabs[], int *fcncount);

extern void clear_update(update_t *update_p, int nfcns);
extern void update_update(update_t *update_p, pi_base_t *estabs, const region_t *rgn_p, 
			  int nfcns, int fcns_per_basrul);


#endif /* MATH_ADAPT_H */





