/*        File: math-intg.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: All versions
   Description: Header file for int. rules and for the functions that call directly call them
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/include/math-intg.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:31 $

                $Log: math-intg.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:31  parint
                Initial checkin


       Version: 01/13/98  rrz  Original
		05/12/98  rrz  Code freeze for ParInt1.0
		05/11/99  rrz  Add prototype for good_intg_rule_parameters()
		07/14/99  rrz  Add protos for new integration rules
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/

#ifndef MATH_INTG_H
#define MATH_INTG_H

#include <parint.h>
#include <pi-defs.h>

/* The integration rule enum values are in parint.h, since they must be user-visible: */
#define valid_intg_rule(irule)  ((irule) >= PI_IRULE_DIM2_DEG13 && (irule) <= PI_IRULE_DQK61)

extern int neval(int ndim, int irule);
extern int fun_wtleng(int ndim, int irule);
extern bool good_intg_rule_parameters(int irule, int ndims, int nfcns);

extern void work_initialize(int ndims, int irule);
extern void work_do_round(int ndims, int nfcns, pi_ifcn_t ifcn_ptr, region_t *region_p);

/* Functions that are the integration rules: */
extern int bsinit_(int *ndim, int *key, int *wtleng, pi_base_t *w, pi_base_t *g, 
		   pi_base_t *errcof, pi_base_t *rulpts, pi_base_t *scales, 
		   pi_base_t *norms);
extern int basrul_(int *ndim, pi_base_t *center, pi_base_t *hwidth, int *wtleng, 
		   pi_base_t *g, pi_base_t *w, pi_base_t *errcof, int *numfun, 
		   int (*funsub)(), pi_base_t *scales, pi_base_t *norms, pi_base_t *x, 
		   pi_base_t *null, pi_base_t *basval, pi_base_t *rgnerr_v, pi_base_t *direct);
extern int dqk15_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);
extern int dqk21_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);
extern int dqk31_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);
extern int dqk41_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);
extern int dqk51_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);
extern int dqk61_(pi_ifcn_t f, pi_base_t centr, pi_base_t hlgth, pi_base_t *result,
		  pi_base_t *abserr, pi_base_t *resabs, pi_base_t *resasc);

#endif /* MATH_INTG_H */
