/*        File: math-rgn.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: All versions (but is region_t specific)
   Description: Header file for routines to manipulate regions
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/include/math-rgn.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:31 $

                $Log: math-rgn.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:31  parint
                Initial checkin


       Version: 01/13/98  rrz  Original (from existing code)
		05/12/98  rrz  Code freeze for ParInt1.0
		11/17/98  rrz  Modify proto for get_initial_region()
		12/18/98  rrz  Modify for changed get_initial_region()
				prototype
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/

#ifndef MATH_RGN_H
#define MATH_RGN_H

#include <pi-defs.h>
#include <parint.h>
#include <pi-vspec.h>

/* Regions are split into two at each step. This cannot be easily changed: */
#define REGION_SPLITS 2

extern pi_base_t volume(int ndims, region_t *rgn_p);
extern void get_initial_region(int ndims, int nworkers, const pi_base_t *a, const pi_base_t *b,
			       int id, region_t *newrgn_p, pi_base_t *full_vol,
			       pi_base_t *local_vol, pi_rparm_t *rparm_p);
extern void split_region(region_t new[], const region_t *oldrgn_p);
extern bool region_has_zero_volume(const pi_base_t a[], pi_base_t const b[], int ndims);

#endif /* MATH_RGN_H */
