/*        File: pi-ifcn.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: All versions
   Description: Header file for integrand function library (types and access routines)
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/include/pi-ifcn.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:31 $

                $Log: pi-ifcn.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:31  parint
                Initial checkin


       Version: 03/02/98  rrz  Original
		05/12/98  rrz  Code freeze for ParInt1.0
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/

/* This header file contains prototypes and definitions allowing ParInt source code
 * to reference the ifcn functions
 */

#ifndef PI_IFCN_H
#define PI_IFCN_H

#include <pi-version.h>
#include <parint.h>
#include <pi-defs.h>


/* Structure holding all stored information about each ifcn.  The ifcn library is an array
 * of these structures: */
typedef struct {
    char           name[PI_MAX_IFCN_NAME + 1];
    char           desc[PI_MAX_IFCN_DESC + 1];
    int            ndims;
    int            nfcns;
    pi_base_t      def_eps_a;
    pi_base_t      def_eps_r;
    int            def_intg_rule;
    int            def_fcn_eval_limit;
    pi_ifcn_t      ifcn_p;
    void *         extra_1;                    /* for future expansion */
    void *         extra_2;                    /* for future expansion */
    pi_base_t      def_answer;                 /* default answer (using all defaults, 1st fcn) */
    pi_base_t      def_a[PI_MAX_NDIM];
    pi_base_t      def_b[PI_MAX_NDIM];
} pi_ifcn_info_t;


extern void pi_ifcn_print_list_lrg(void);
extern void pi_ifcn_print_list_sm(void);
extern pi_ifcn_t pi_ifcn_lookup_ifcn(const char *ifcn_name);
extern pi_iparm_t *pi_ifcn_lookup_iparms(const char *ifcn_name);
extern char *pi_ifcn_lookup_desc(const char *ifcn_name);
extern pi_ifcn_info_t *pi_ifcn_get_table(int *nproblems);
extern pi_ifcn_info_t *pi_ifcn_lookup_info(const char *ifcn_name);

#endif /* PI_IFCN_H */
