/*        File: random.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: All
   Description: Header file for pseudo-random number functions
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/include/random.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:32 $

                $Log: random.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:32  parint
                Initial checkin


       Version: 09/13/99  rrz  Original (from old code of mine)
*/

#ifndef RANDOM_H
#define RANDOM_H

#include <stdlib.h>        /* (for RAND_MAX) */

extern void random_init(void);
extern void random_init_with_help(short help);

/* Returns a random number from 1 ... n inclusive.  It is assumed
 * that the random number seed has already been initialized
 */
#define random_1n(n) ((rand() % (n)) + 1)

/* Returns a pseudo-random number x that is minval <= x <= maxval
 */
#define random_decimal_1n(minval, maxval)  ((minval) +                                            \
                                            (((maxval) - (minval)) * (1.0 / random_1n(RAND_MAX))))
#endif /* RANDOM_H */
