/*        File: visual.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: MPI (visualization)
   Description: Header file for visualization code
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/mpi/visual.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:34 $

                $Log: visual.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:34  parint
                Initial checkin


       Version: 07/03/98  jli  Original
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/
 
/* This header file is for all defintions and prototypes that
    related to visualization */


/* read request from the java Applet */
extern void vis_read_request(int new_sockfd,int num_non_ic_workers,bool ic_is_worker, 
			     MPI_Comm comm);

/* send local eps & # of regions to Applet */
extern void vis_send_update(int sockfd, int worker_id,update_t wrkr_update);

/* initialize visulization */
extern void vis_init_connect(int portno,int num_non_ic_workers,int *new_sockfd,MPI_Comm comm);

/* receive histogram from a worker, then send it to the Applet */
extern void vis_recv_hist(int new_sockfd,MPI_Comm comm);

/* update # regions, estabs..etc. for ctrl -as worker */ 
extern void vis_caw_update_update(update_t *update_p, pi_base_t *estabs, int nfcns, double l_time,
				  double rgnerr);

/* below are functions for workers */

/* get number of regions of a heapnode */
extern long vis_get_num_region(hnode *p, double threshold);

/* return # region for controller as worker */
long vis_caw_get_num_region(hnode* p);

/* get the histogram from the heap */
extern void vis_get_hist(hnode *p, hist_t *hist,int hist_type,double l_time);

/* update # regions, estabs..etc. */
extern void vis_update_update(update_t *update_p, pi_base_t *estabs, int nfcns, double l_time,
			      long num_region);

/* the following two fns are to
 maintain the minimum region err */
extern void vis_init_min_err(region_t rgn);

extern void vis_min_rgn_err(region_t rgn);

/* close the sockets */
extern void vis_close(int new_sockfd);

