/*        File: pi-version.h
     Copyright: (C) 1998,1999,2000 by Elise de Doncker, Ajay Gupta, Alan Genz & Rodger Zanny. 
                    All rights reserved. See file COPYRIGHT in top-level directory.
  ParInt Versn: SEQ version (slightly different from MPI version)
   Description: Header file, defined for each ParInt version.  Defines basic parameters.
           CVS: $Source: /home/other/parint/cvsroot/parint1.1/src/seq/pi-version.h,v $
                $Author: parint $
                $Revision: 1.1.1.1 $
                $Date: 2000/06/06 03:13:34 $

                $Log: pi-version.h,v $
                Revision 1.1.1.1  2000/06/06 03:13:34  parint
                Initial checkin


       Version: 01/13/98  rrz  Original
		05/12/98  rrz  Code freeze for ParInt1.0
		05/01/99  rrz  Remove TAG_BASE and USE_MSG_DEBUG for the seq
				version
		07/23/99  rrz  --- Code freeze for ParInt1.1 ---
*/

/* This header file belongs in each version's directory, and will have the same form across
 * all versions, differing only in what items are enabled or disabled.  Note that if the 
 * Makefiles do not include all dependencies (which, as of now, they do not), then after making
 * a change in here, you should do a make clean before recompiling ParInt.
 */

#ifndef PI_VERSION_H
#define PI_VERSION_H

/* These control the debugging messages over all files.  NO_FILES overrules ALL_FILES.  If
 * neither is defined, then debugging is on a file-by-file basis: */
/* #define DBG_ALL_FILES */
#define DBG_NO_FILES

/* This enables compile-time options wanted when using ParInt to experiment with new
 * algorithms, etc...  Mostly it just turns on some more printing: */
/* #define WE_ARE_AT_WMU */

/* Enable to this add extra, paranoid, run-time checks: */
/* #define USE_MY_ASSERTIONS */

/* Enable this to use long doubles, else use doubles (for all results, regions, etc...): */
/* #define USING_LONG_DOUBLES */

/* NOTE: If PI_MAX_NDIM changes, then the arrays in ifcn-ctrl.h must change.  This is annoying,
 * but vastly simplifies things.  This annoyance will pass when we use dynamically allocated
 * arrays: */
#define PI_MAX_NDIM   10             /* Max dimension over which integrating     */
#define PI_MAX_NFCN   10             /* Max number of integrands                 */

#endif /* PI_VERSION_H */

